// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 36 "src/parser.yy"

#include <iostream>

#include "driver.h"
#include "lexer.h"

void yyerror(bpftrace::Driver &driver, const char *s);

#line 50 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"


#include "parser.tab.hh"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 4 "src/parser.yy"
namespace  bpftrace  {
#line 148 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"

  /// Build a parser object.
  Parser::Parser (bpftrace::Driver &driver_yyarg, void *yyscanner_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      yyscanner (yyscanner_yyarg)
  {}

  Parser::~Parser ()
  {}

  Parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------.
  | symbol.  |
  `---------*/



  // by_state.
  Parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  Parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  Parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  Parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  Parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  Parser::symbol_kind_type
  Parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  Parser::stack_symbol_type::stack_symbol_type ()
  {}

  Parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_int_type: // int_type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        value.YY_MOVE_OR_COPY< SizedType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_point: // attach_point
        value.YY_MOVE_OR_COPY< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.YY_MOVE_OR_COPY< ast::AttachPointList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_call: // call
        value.YY_MOVE_OR_COPY< ast::Call * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.YY_MOVE_OR_COPY< ast::Expression * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vargs: // vargs
        value.YY_MOVE_OR_COPY< ast::ExpressionList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_int: // int
        value.YY_MOVE_OR_COPY< ast::Integer * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map: // map
        value.YY_MOVE_OR_COPY< ast::Map * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        value.YY_MOVE_OR_COPY< ast::Offsetof * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.YY_MOVE_OR_COPY< ast::Operator > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_param: // param
        value.YY_MOVE_OR_COPY< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pred: // pred
        value.YY_MOVE_OR_COPY< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probe: // probe
        value.YY_MOVE_OR_COPY< ast::Probe * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probes: // probes
        value.YY_MOVE_OR_COPY< ast::ProbeList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        value.YY_MOVE_OR_COPY< ast::Sizeof * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.YY_MOVE_OR_COPY< ast::Statement * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.YY_MOVE_OR_COPY< ast::StatementList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_var: // var
        value.YY_MOVE_OR_COPY< ast::Variable * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INT: // "integer"
        value.YY_MOVE_OR_COPY< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_INT_TYPE: // "integer type"
      case symbol_kind::S_BUILTIN_TYPE: // "builtin type"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  Parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_int_type: // int_type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        value.move< SizedType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_point: // attach_point
        value.move< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.move< ast::AttachPointList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_call: // call
        value.move< ast::Call * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.move< ast::Expression * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vargs: // vargs
        value.move< ast::ExpressionList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_int: // int
        value.move< ast::Integer * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map: // map
        value.move< ast::Map * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        value.move< ast::Offsetof * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.move< ast::Operator > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_param: // param
        value.move< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pred: // pred
        value.move< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probe: // probe
        value.move< ast::Probe * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probes: // probes
        value.move< ast::ProbeList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        value.move< ast::Sizeof * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.move< ast::Statement * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.move< ast::StatementList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_var: // var
        value.move< ast::Variable * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INT: // "integer"
        value.move< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_INT_TYPE: // "integer type"
      case symbol_kind::S_BUILTIN_TYPE: // "builtin type"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.move< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_int_type: // int_type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        value.copy< SizedType > (that.value);
        break;

      case symbol_kind::S_attach_point: // attach_point
        value.copy< ast::AttachPoint * > (that.value);
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.copy< ast::AttachPointList * > (that.value);
        break;

      case symbol_kind::S_call: // call
        value.copy< ast::Call * > (that.value);
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.copy< ast::Expression * > (that.value);
        break;

      case symbol_kind::S_vargs: // vargs
        value.copy< ast::ExpressionList * > (that.value);
        break;

      case symbol_kind::S_int: // int
        value.copy< ast::Integer * > (that.value);
        break;

      case symbol_kind::S_map: // map
        value.copy< ast::Map * > (that.value);
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        value.copy< ast::Offsetof * > (that.value);
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.copy< ast::Operator > (that.value);
        break;

      case symbol_kind::S_param: // param
        value.copy< ast::PositionalParameter * > (that.value);
        break;

      case symbol_kind::S_pred: // pred
        value.copy< ast::Predicate * > (that.value);
        break;

      case symbol_kind::S_probe: // probe
        value.copy< ast::Probe * > (that.value);
        break;

      case symbol_kind::S_probes: // probes
        value.copy< ast::ProbeList * > (that.value);
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        value.copy< ast::Sizeof * > (that.value);
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.copy< ast::Statement * > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.copy< ast::StatementList * > (that.value);
        break;

      case symbol_kind::S_var: // var
        value.copy< ast::Variable * > (that.value);
        break;

      case symbol_kind::S_INT: // "integer"
        value.copy< int64_t > (that.value);
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_INT_TYPE: // "integer type"
      case symbol_kind::S_BUILTIN_TYPE: // "builtin type"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.copy< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_int_type: // int_type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        value.move< SizedType > (that.value);
        break;

      case symbol_kind::S_attach_point: // attach_point
        value.move< ast::AttachPoint * > (that.value);
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.move< ast::AttachPointList * > (that.value);
        break;

      case symbol_kind::S_call: // call
        value.move< ast::Call * > (that.value);
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.move< ast::Expression * > (that.value);
        break;

      case symbol_kind::S_vargs: // vargs
        value.move< ast::ExpressionList * > (that.value);
        break;

      case symbol_kind::S_int: // int
        value.move< ast::Integer * > (that.value);
        break;

      case symbol_kind::S_map: // map
        value.move< ast::Map * > (that.value);
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        value.move< ast::Offsetof * > (that.value);
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.move< ast::Operator > (that.value);
        break;

      case symbol_kind::S_param: // param
        value.move< ast::PositionalParameter * > (that.value);
        break;

      case symbol_kind::S_pred: // pred
        value.move< ast::Predicate * > (that.value);
        break;

      case symbol_kind::S_probe: // probe
        value.move< ast::Probe * > (that.value);
        break;

      case symbol_kind::S_probes: // probes
        value.move< ast::ProbeList * > (that.value);
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        value.move< ast::Sizeof * > (that.value);
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.move< ast::Statement * > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.move< ast::StatementList * > (that.value);
        break;

      case symbol_kind::S_var: // var
        value.move< ast::Variable * > (that.value);
        break;

      case symbol_kind::S_INT: // "integer"
        value.move< int64_t > (that.value);
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_INT_TYPE: // "integer type"
      case symbol_kind::S_BUILTIN_TYPE: // "builtin type"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.move< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  Parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  Parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  Parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  Parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  Parser::yypop_ (int n) YY_NOEXCEPT
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Parser::debug_level_type
  Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  Parser::state_type
  Parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  Parser::yy_pact_value_is_default_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  Parser::yy_table_value_is_error_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Parser::operator() ()
  {
    return parse ();
  }

  int
  Parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            symbol_type yylookahead (yylex (driver, yyscanner));
            yyla.move (yylookahead);
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_int_type: // int_type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        yylhs.value.emplace< SizedType > ();
        break;

      case symbol_kind::S_attach_point: // attach_point
        yylhs.value.emplace< ast::AttachPoint * > ();
        break;

      case symbol_kind::S_attach_points: // attach_points
        yylhs.value.emplace< ast::AttachPointList * > ();
        break;

      case symbol_kind::S_call: // call
        yylhs.value.emplace< ast::Call * > ();
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        yylhs.value.emplace< ast::Expression * > ();
        break;

      case symbol_kind::S_vargs: // vargs
        yylhs.value.emplace< ast::ExpressionList * > ();
        break;

      case symbol_kind::S_int: // int
        yylhs.value.emplace< ast::Integer * > ();
        break;

      case symbol_kind::S_map: // map
        yylhs.value.emplace< ast::Map * > ();
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        yylhs.value.emplace< ast::Offsetof * > ();
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        yylhs.value.emplace< ast::Operator > ();
        break;

      case symbol_kind::S_param: // param
        yylhs.value.emplace< ast::PositionalParameter * > ();
        break;

      case symbol_kind::S_pred: // pred
        yylhs.value.emplace< ast::Predicate * > ();
        break;

      case symbol_kind::S_probe: // probe
        yylhs.value.emplace< ast::Probe * > ();
        break;

      case symbol_kind::S_probes: // probes
        yylhs.value.emplace< ast::ProbeList * > ();
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        yylhs.value.emplace< ast::Sizeof * > ();
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        yylhs.value.emplace< ast::Statement * > ();
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        yylhs.value.emplace< ast::StatementList * > ();
        break;

      case symbol_kind::S_var: // var
        yylhs.value.emplace< ast::Variable * > ();
        break;

      case symbol_kind::S_INT: // "integer"
        yylhs.value.emplace< int64_t > ();
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_INT_TYPE: // "integer type"
      case symbol_kind::S_BUILTIN_TYPE: // "builtin type"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        yylhs.value.emplace< std::string > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // program: c_definitions probes "end of file"
#line 172 "src/parser.yy"
                                         { driver.root = std::make_unique<ast::Program>(yystack_[2].value.as < std::string > (), yystack_[1].value.as < ast::ProbeList * > ()); }
#line 1173 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 3: // c_definitions: "preprocessor directive" c_definitions
#line 176 "src/parser.yy"
                                                 { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "\n" + yystack_[0].value.as < std::string > (); }
#line 1179 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 4: // c_definitions: "struct" "struct definition" c_definitions
#line 177 "src/parser.yy"
                                                 { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1185 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 5: // c_definitions: "struct" "enum" c_definitions
#line 178 "src/parser.yy"
                                                 { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1191 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 6: // c_definitions: %empty
#line 179 "src/parser.yy"
                                                 { yylhs.value.as < std::string > () = std::string(); }
#line 1197 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 7: // type: int_type
#line 183 "src/parser.yy"
                         { yylhs.value.as < SizedType > () = yystack_[0].value.as < SizedType > (); }
#line 1203 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 8: // type: "builtin type"
#line 184 "src/parser.yy"
                             {
                    static std::unordered_map<std::string, SizedType> type_map = {
                        {"min_t", CreateMin(true)},
                        {"max_t", CreateMax(true)},
                        {"sum_t", CreateSum(true)},
                        {"count_t", CreateCount(true)},
                        {"avg_t", CreateAvg(true)},
                        {"stats_t", CreateStats(true)},
                        {"umin_t", CreateMin(false)},
                        {"umax_t", CreateMax(false)},
                        {"usum_t", CreateSum(false)},
                        {"ucount_t", CreateCount(false)},
                        {"uavg_t", CreateAvg(false)},
                        {"ustats_t", CreateStats(false)},
                        {"timestamp_t", CreateTimestamp()},
                        {"macaddr_t", CreateMacAddress()},
                        {"cgroup_path_t", CreateCgroupPath()},
                        {"strerror_t", CreateStrerror()},
                    };
                    yylhs.value.as < SizedType > () = type_map[yystack_[0].value.as < std::string > ()];
                }
#line 1229 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 9: // type: "sized type" "[" "integer" "]"
#line 205 "src/parser.yy"
                                       {
                    if (yystack_[3].value.as < std::string > () == "str_t") {
                        yylhs.value.as < SizedType > () = CreateString(yystack_[1].value.as < int64_t > ());
                    } else if (yystack_[3].value.as < std::string > () == "inet_t") {
                        yylhs.value.as < SizedType > () = CreateInet(yystack_[1].value.as < int64_t > ());
                    } else if (yystack_[3].value.as < std::string > () == "buf_t") {
                        yylhs.value.as < SizedType > () = CreateBuffer(yystack_[1].value.as < int64_t > ());
                    }
                }
#line 1243 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 10: // type: int_type "[" "integer" "]"
#line 214 "src/parser.yy"
                                     {
                  yylhs.value.as < SizedType > () = CreateArray(yystack_[1].value.as < int64_t > (), yystack_[3].value.as < SizedType > ());
                }
#line 1251 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 11: // type: int_type "[" "]"
#line 217 "src/parser.yy"
                                 {
                  yylhs.value.as < SizedType > () = CreateArray(0, yystack_[2].value.as < SizedType > ());
                }
#line 1259 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 12: // type: pointer_type
#line 220 "src/parser.yy"
                             { yylhs.value.as < SizedType > () = yystack_[0].value.as < SizedType > (); }
#line 1265 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 13: // type: struct_type
#line 221 "src/parser.yy"
                            { yylhs.value.as < SizedType > () = yystack_[0].value.as < SizedType > (); }
#line 1271 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 14: // int_type: "integer type"
#line 225 "src/parser.yy"
                         {
                    static std::unordered_map<std::string, SizedType> type_map = {
                        {"bool", CreateBool()},
                        {"uint8", CreateUInt(8)},
                        {"uint16", CreateUInt(16)},
                        {"uint32", CreateUInt(32)},
                        {"uint64", CreateUInt(64)},
                        {"int8", CreateInt(8)},
                        {"int16", CreateInt(16)},
                        {"int32", CreateInt(32)},
                        {"int64", CreateInt(64)},
                    };
                    yylhs.value.as < SizedType > () = type_map[yystack_[0].value.as < std::string > ()];
                }
#line 1290 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 15: // pointer_type: type "*"
#line 242 "src/parser.yy"
                         { yylhs.value.as < SizedType > () = CreatePointer(yystack_[1].value.as < SizedType > ()); }
#line 1296 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 16: // struct_type: "struct" "identifier"
#line 245 "src/parser.yy"
                             { yylhs.value.as < SizedType > () = ast::ident_to_record(yystack_[0].value.as < std::string > ()); }
#line 1302 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 17: // probes: probes probe
#line 249 "src/parser.yy"
                             { yylhs.value.as < ast::ProbeList * > () = yystack_[1].value.as < ast::ProbeList * > (); yystack_[1].value.as < ast::ProbeList * > ()->push_back(yystack_[0].value.as < ast::Probe * > ()); }
#line 1308 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 18: // probes: probe
#line 250 "src/parser.yy"
                             { yylhs.value.as < ast::ProbeList * > () = new ast::ProbeList; yylhs.value.as < ast::ProbeList * > ()->push_back(yystack_[0].value.as < ast::Probe * > ()); }
#line 1314 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 19: // probe: attach_points pred block
#line 255 "src/parser.yy"
                {
                  if (!driver.listing_)
                    yylhs.value.as < ast::Probe * > () = new ast::Probe(yystack_[2].value.as < ast::AttachPointList * > (), yystack_[1].value.as < ast::Predicate * > (), yystack_[0].value.as < ast::StatementList * > ());
                  else
                  {
                    error(yylhs.location, "unexpected listing query format");
                    YYERROR;
                  }
                }
#line 1328 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 20: // probe: attach_points "end of file"
#line 265 "src/parser.yy"
                {
                  if (driver.listing_)
                    yylhs.value.as < ast::Probe * > () = new ast::Probe(yystack_[1].value.as < ast::AttachPointList * > (), nullptr, nullptr);
                  else
                  {
                    error(yylhs.location, "unexpected end of file, expected {");
                    YYERROR;
                  }
                }
#line 1342 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 21: // attach_points: attach_points "," attach_point
#line 277 "src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList * > () = yystack_[2].value.as < ast::AttachPointList * > (); yystack_[2].value.as < ast::AttachPointList * > ()->push_back(yystack_[0].value.as < ast::AttachPoint * > ()); }
#line 1348 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 22: // attach_points: attach_point
#line 278 "src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList * > () = new ast::AttachPointList; yylhs.value.as < ast::AttachPointList * > ()->push_back(yystack_[0].value.as < ast::AttachPoint * > ()); }
#line 1354 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 23: // attach_point: attach_point_def
#line 282 "src/parser.yy"
                                                { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1360 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 24: // attach_point_def: attach_point_def ident
#line 286 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + yystack_[0].value.as < std::string > (); }
#line 1366 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 25: // attach_point_def: attach_point_def "string"
#line 290 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "\"" + std::regex_replace(yystack_[0].value.as < std::string > (), std::regex("\""), "\\\"") + "\""; }
#line 1372 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 26: // attach_point_def: attach_point_def "path"
#line 291 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + yystack_[0].value.as < std::string > (); }
#line 1378 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 27: // attach_point_def: attach_point_def "integer"
#line 292 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + std::to_string(yystack_[0].value.as < int64_t > ()); }
#line 1384 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 28: // attach_point_def: attach_point_def ":"
#line 293 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ":"; }
#line 1390 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 29: // attach_point_def: attach_point_def "."
#line 294 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "."; }
#line 1396 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 30: // attach_point_def: attach_point_def "+"
#line 295 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "+"; }
#line 1402 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 31: // attach_point_def: attach_point_def "*"
#line 296 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "*"; }
#line 1408 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 32: // attach_point_def: attach_point_def "["
#line 297 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "["; }
#line 1414 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 33: // attach_point_def: attach_point_def "]"
#line 298 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "]"; }
#line 1420 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 34: // attach_point_def: attach_point_def param
#line 300 "src/parser.yy"
                {
                  if (yystack_[0].value.as < ast::PositionalParameter * > ()->ptype != PositionalParameterType::positional)
                  {
                    error(yylhs.location, "Not a positional parameter");
                    YYERROR;
                  }
                  // "Un-parse" the positional parameter back into text so
                  // we can give it to the AttachPointParser. This is kind of
                  // a hack but there doesn't look to be any other way.
                  yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "$" + std::to_string(yystack_[0].value.as < ast::PositionalParameter * > ()->n);
                  delete yystack_[0].value.as < ast::PositionalParameter * > ();
                }
#line 1437 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 35: // attach_point_def: %empty
#line 312 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = ""; }
#line 1443 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 36: // pred: "/" expr "end predicate"
#line 316 "src/parser.yy"
                                 { yylhs.value.as < ast::Predicate * > () = new ast::Predicate(yystack_[1].value.as < ast::Expression * > (), yylhs.location); }
#line 1449 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 37: // pred: %empty
#line 317 "src/parser.yy"
                                  { yylhs.value.as < ast::Predicate * > () = nullptr; }
#line 1455 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 38: // param: "positional parameter"
#line 322 "src/parser.yy"
                      {
                        try {
                          long n = std::stol(yystack_[0].value.as < std::string > ().substr(1, yystack_[0].value.as < std::string > ().size()-1));
                          if (n == 0) throw std::exception();
                          yylhs.value.as < ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::positional, n, yylhs.location);
                        } catch (std::exception const& e) {
                          error(yystack_[0].location, "param " + yystack_[0].value.as < std::string > () + " is out of integer range [1, " +
                                std::to_string(std::numeric_limits<long>::max()) + "]");
                          YYERROR;
                        }
                      }
#line 1471 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 39: // param: "$#"
#line 333 "src/parser.yy"
                           { yylhs.value.as < ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::count, 0, yylhs.location); }
#line 1477 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 40: // block: "{" stmt_list "}"
#line 337 "src/parser.yy"
                                      { yylhs.value.as < ast::StatementList * > () = yystack_[1].value.as < ast::StatementList * > (); }
#line 1483 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 41: // stmt_list: expr_stmt ";" stmt_list
#line 344 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[2].value.as < ast::Statement * > ()); }
#line 1489 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 42: // stmt_list: expr_stmt
#line 345 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; yylhs.value.as < ast::StatementList * > ()->push_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1495 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 43: // stmt_list: block_stmt stmt_list
#line 349 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[1].value.as < ast::Statement * > ()); }
#line 1501 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 44: // stmt_list: %empty
#line 350 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; }
#line 1507 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 45: // block_stmt: loop_stmt
#line 354 "src/parser.yy"
                             { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1513 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 46: // block_stmt: if_stmt
#line 355 "src/parser.yy"
                             { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1519 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 47: // expr_stmt: expr
#line 359 "src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = new ast::ExprStatement(yystack_[0].value.as < ast::Expression * > (), yystack_[0].location); }
#line 1525 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 48: // expr_stmt: jump_stmt
#line 360 "src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1531 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 49: // expr_stmt: assign_stmt
#line 365 "src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1537 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 50: // jump_stmt: "break"
#line 369 "src/parser.yy"
                         { yylhs.value.as < ast::Statement * > () = new ast::Jump(ast::JumpType::BREAK, yylhs.location); }
#line 1543 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 51: // jump_stmt: "continue"
#line 370 "src/parser.yy"
                         { yylhs.value.as < ast::Statement * > () = new ast::Jump(ast::JumpType::CONTINUE, yylhs.location); }
#line 1549 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 52: // jump_stmt: "return"
#line 371 "src/parser.yy"
                         { yylhs.value.as < ast::Statement * > () = new ast::Jump(ast::JumpType::RETURN, yylhs.location); }
#line 1555 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 53: // loop_stmt: "unroll" "(" int ")" block
#line 375 "src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::Unroll(yystack_[2].value.as < ast::Integer * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location + yystack_[1].location); }
#line 1561 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 54: // loop_stmt: "unroll" "(" param ")" block
#line 376 "src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::Unroll(yystack_[2].value.as < ast::PositionalParameter * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location + yystack_[1].location); }
#line 1567 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 55: // loop_stmt: "while" "(" expr ")" block
#line 377 "src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::While(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location); }
#line 1573 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 56: // if_stmt: "if" "(" expr ")" block
#line 381 "src/parser.yy"
                                                       { yylhs.value.as < ast::Statement * > () = new ast::If(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1579 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 57: // if_stmt: "if" "(" expr ")" block "else" block_or_if
#line 382 "src/parser.yy"
                                                       { yylhs.value.as < ast::Statement * > () = new ast::If(yystack_[4].value.as < ast::Expression * > (), yystack_[2].value.as < ast::StatementList * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1585 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 58: // block_or_if: block
#line 386 "src/parser.yy"
                             { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); }
#line 1591 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 59: // block_or_if: if_stmt
#line 387 "src/parser.yy"
                             { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; yylhs.value.as < ast::StatementList * > ()->emplace_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1597 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 60: // assign_stmt: tuple_access_expr "=" expr
#line 392 "src/parser.yy"
                {
                  error(yystack_[2].location + yystack_[0].location, "Tuples are immutable once created. Consider creating a new tuple and assigning it instead.");
                  YYERROR;
                }
#line 1606 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 61: // assign_stmt: map "=" expr
#line 396 "src/parser.yy"
                                     { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), yystack_[0].value.as < ast::Expression * > (), false, yystack_[1].location); }
#line 1612 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 62: // assign_stmt: var "=" expr
#line 397 "src/parser.yy"
                                     { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), yystack_[0].value.as < ast::Expression * > (), false, yystack_[1].location); }
#line 1618 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 63: // assign_stmt: map compound_op expr
#line 399 "src/parser.yy"
                {
                  auto b = new ast::Binop(yystack_[2].value.as < ast::Map * > (), yystack_[1].value.as < ast::Operator > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location);
                  yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), b, true, yylhs.location);
                }
#line 1627 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 64: // assign_stmt: var compound_op expr
#line 404 "src/parser.yy"
                {
                  auto b = new ast::Binop(yystack_[2].value.as < ast::Variable * > (), yystack_[1].value.as < ast::Operator > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location);
                  yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), b, true, yylhs.location);
                }
#line 1636 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 65: // primary_expr: "identifier"
#line 411 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::Identifier(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1642 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 66: // primary_expr: int
#line 412 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Integer * > (); }
#line 1648 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 67: // primary_expr: "string"
#line 413 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::String(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1654 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 68: // primary_expr: "stack_mode"
#line 414 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::StackMode(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1660 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 69: // primary_expr: "builtin"
#line 415 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::Builtin(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1666 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 70: // primary_expr: "call_builtin"
#line 416 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::Builtin(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1672 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 71: // primary_expr: "(" expr ")"
#line 417 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[1].value.as < ast::Expression * > (); }
#line 1678 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 72: // primary_expr: param
#line 418 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::PositionalParameter * > (); }
#line 1684 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 73: // primary_expr: map_or_var
#line 419 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1690 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 74: // primary_expr: "(" expr "," vargs ")"
#line 421 "src/parser.yy"
                {
                  auto args = new ast::ExpressionList;
                  args->emplace_back(yystack_[3].value.as < ast::Expression * > ());
                  args->insert(args->end(), yystack_[1].value.as < ast::ExpressionList * > ()->begin(), yystack_[1].value.as < ast::ExpressionList * > ()->end());
                  yylhs.value.as < ast::Expression * > () = new ast::Tuple(args, yylhs.location);
                }
#line 1701 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 75: // postfix_expr: primary_expr
#line 430 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1707 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 76: // postfix_expr: postfix_expr "." ident
#line 432 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < std::string > (), yystack_[1].location); }
#line 1713 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 77: // postfix_expr: postfix_expr "->" ident
#line 433 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(new ast::Unop(ast::Operator::MUL, yystack_[2].value.as < ast::Expression * > (), yystack_[1].location), yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1719 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 78: // postfix_expr: tuple_access_expr
#line 435 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1725 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 79: // postfix_expr: postfix_expr "[" expr "]"
#line 437 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::ArrayAccess(yystack_[3].value.as < ast::Expression * > (), yystack_[1].value.as < ast::Expression * > (), yystack_[2].location + yystack_[0].location); }
#line 1731 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 80: // postfix_expr: call
#line 438 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Call * > (); }
#line 1737 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 81: // postfix_expr: sizeof_expr
#line 439 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Sizeof * > (); }
#line 1743 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 82: // postfix_expr: offsetof_expr
#line 440 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Offsetof * > (); }
#line 1749 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 83: // postfix_expr: map_or_var "++"
#line 441 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::Unop(ast::Operator::INCREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 1755 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 84: // postfix_expr: map_or_var "--"
#line 442 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::Unop(ast::Operator::DECREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 1761 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 85: // postfix_expr: "++" ident
#line 444 "src/parser.yy"
                                          { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 1767 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 86: // postfix_expr: "--" ident
#line 445 "src/parser.yy"
                                          { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 1773 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 87: // tuple_access_expr: postfix_expr "." "integer"
#line 450 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < int64_t > (), yystack_[0].location); }
#line 1779 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 88: // unary_expr: unary_op cast_expr
#line 456 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(yystack_[1].value.as < ast::Operator > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1785 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 89: // unary_expr: postfix_expr
#line 457 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1791 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 90: // unary_expr: "++" map_or_var
#line 458 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(ast::Operator::INCREMENT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1797 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 91: // unary_expr: "--" map_or_var
#line 459 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(ast::Operator::DECREMENT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1803 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 92: // unary_expr: ident "--"
#line 461 "src/parser.yy"
                                     { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 1809 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 93: // unary_expr: ident "++"
#line 462 "src/parser.yy"
                                     { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 1815 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 94: // unary_op: "*"
#line 466 "src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::MUL; }
#line 1821 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 95: // unary_op: "~"
#line 467 "src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::BNOT; }
#line 1827 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 96: // unary_op: "!"
#line 468 "src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::LNOT; }
#line 1833 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 97: // unary_op: "-"
#line 469 "src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::MINUS; }
#line 1839 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 98: // expr: conditional_expr
#line 473 "src/parser.yy"
                                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1845 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 99: // conditional_expr: logical_or_expr
#line 477 "src/parser.yy"
                                                                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1851 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 100: // conditional_expr: logical_or_expr "?" expr ":" conditional_expr
#line 478 "src/parser.yy"
                                                                 { yylhs.value.as < ast::Expression * > () = new ast::Ternary(yystack_[4].value.as < ast::Expression * > (), yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::Expression * > (), yylhs.location); }
#line 1857 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 101: // logical_or_expr: logical_and_expr
#line 483 "src/parser.yy"
                                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1863 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 102: // logical_or_expr: logical_or_expr "||" logical_and_expr
#line 484 "src/parser.yy"
                                                     { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1869 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 103: // logical_and_expr: or_expr
#line 488 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1875 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 104: // logical_and_expr: logical_and_expr "&&" or_expr
#line 489 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LAND, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1881 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 105: // or_expr: xor_expr
#line 493 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1887 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 106: // or_expr: or_expr "|" xor_expr
#line 494 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::BOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1893 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 107: // xor_expr: and_expr
#line 498 "src/parser.yy"
                                       { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1899 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 108: // xor_expr: xor_expr "^" and_expr
#line 499 "src/parser.yy"
                                       { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::BXOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1905 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 109: // and_expr: equality_expr
#line 504 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1911 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 110: // and_expr: and_expr "&" equality_expr
#line 505 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::BAND, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1917 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 111: // equality_expr: relational_expr
#line 509 "src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1923 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 112: // equality_expr: equality_expr "==" relational_expr
#line 510 "src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::EQ, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1929 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 113: // equality_expr: equality_expr "!=" relational_expr
#line 511 "src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::NE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1935 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 114: // relational_expr: shift_expr
#line 515 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1941 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 115: // relational_expr: relational_expr "<=" shift_expr
#line 516 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1947 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 116: // relational_expr: relational_expr ">=" shift_expr
#line 517 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::GE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1953 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 117: // relational_expr: relational_expr "<" shift_expr
#line 518 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1959 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 118: // relational_expr: relational_expr ">" shift_expr
#line 519 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::GT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1965 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 119: // shift_expr: addi_expr
#line 523 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1971 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 120: // shift_expr: shift_expr "<<" addi_expr
#line 524 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LEFT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1977 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 121: // shift_expr: shift_expr ">>" addi_expr
#line 525 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::RIGHT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1983 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 122: // muli_expr: cast_expr
#line 529 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1989 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 123: // muli_expr: muli_expr "*" cast_expr
#line 530 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::MUL, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1995 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 124: // muli_expr: muli_expr "/" cast_expr
#line 531 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::DIV, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2001 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 125: // muli_expr: muli_expr "%" cast_expr
#line 532 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::MOD, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2007 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 126: // addi_expr: muli_expr
#line 536 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2013 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 127: // addi_expr: addi_expr "+" muli_expr
#line 537 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::PLUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2019 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 128: // addi_expr: addi_expr "-" muli_expr
#line 538 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::MINUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 2025 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 129: // cast_expr: unary_expr
#line 542 "src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 2031 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 130: // cast_expr: "(" type ")" cast_expr
#line 543 "src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = new ast::Cast(yystack_[2].value.as < SizedType > (), yystack_[0].value.as < ast::Expression * > (), yystack_[3].location + yystack_[1].location); }
#line 2037 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 131: // cast_expr: "(" "identifier" ")" cast_expr
#line 545 "src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = new ast::Cast(ast::ident_to_record(yystack_[2].value.as < std::string > (), 0), yystack_[0].value.as < ast::Expression * > (), yystack_[3].location + yystack_[1].location); }
#line 2043 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 132: // cast_expr: "(" "identifier" "*" ")" cast_expr
#line 546 "src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = new ast::Cast(ast::ident_to_record(yystack_[3].value.as < std::string > (), 1), yystack_[0].value.as < ast::Expression * > (), yystack_[4].location + yystack_[1].location); }
#line 2049 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 133: // cast_expr: "(" "identifier" "*" "*" ")" cast_expr
#line 547 "src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = new ast::Cast(ast::ident_to_record(yystack_[4].value.as < std::string > (), 2), yystack_[0].value.as < ast::Expression * > (), yystack_[5].location + yystack_[1].location); }
#line 2055 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 134: // sizeof_expr: "sizeof" "(" type ")"
#line 551 "src/parser.yy"
                                                            { yylhs.value.as < ast::Sizeof * > () = new ast::Sizeof(yystack_[1].value.as < SizedType > (), yylhs.location); }
#line 2061 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 135: // sizeof_expr: "sizeof" "(" expr ")"
#line 552 "src/parser.yy"
                                                            { yylhs.value.as < ast::Sizeof * > () = new ast::Sizeof(yystack_[1].value.as < ast::Expression * > (), yylhs.location); }
#line 2067 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 136: // offsetof_expr: "offsetof" "(" struct_type "," ident ")"
#line 556 "src/parser.yy"
                                                            { yylhs.value.as < ast::Offsetof * > () = new ast::Offsetof(yystack_[3].value.as < SizedType > (), yystack_[1].value.as < std::string > (), yylhs.location); }
#line 2073 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 137: // offsetof_expr: "offsetof" "(" expr "," ident ")"
#line 558 "src/parser.yy"
                                                            { yylhs.value.as < ast::Offsetof * > () = new ast::Offsetof(yystack_[3].value.as < ast::Expression * > (), yystack_[1].value.as < std::string > (), yylhs.location); }
#line 2079 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 138: // int: "-" "integer"
#line 562 "src/parser.yy"
                             { yylhs.value.as < ast::Integer * > () = new ast::Integer((int64_t)(~(uint64_t)(yystack_[0].value.as < int64_t > ()) + 1), yylhs.location); }
#line 2085 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 139: // int: "integer"
#line 563 "src/parser.yy"
                             { yylhs.value.as < ast::Integer * > () = new ast::Integer(yystack_[0].value.as < int64_t > (), yylhs.location); }
#line 2091 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 140: // ident: "identifier"
#line 567 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2097 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 141: // ident: "builtin"
#line 568 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2103 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 142: // ident: "call"
#line 569 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2109 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 143: // ident: "call_builtin"
#line 570 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2115 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 144: // ident: "stack_mode"
#line 571 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2121 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 145: // call: "call" "(" ")"
#line 575 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 2127 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 146: // call: "call" "(" vargs ")"
#line 576 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 2133 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 147: // call: "call_builtin" "(" ")"
#line 577 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 2139 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 148: // call: "call_builtin" "(" vargs ")"
#line 578 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 2145 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 149: // call: "identifier" "(" ")"
#line 579 "src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 2151 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 150: // call: "identifier" "(" vargs ")"
#line 580 "src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 2157 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 151: // call: "builtin" "(" ")"
#line 581 "src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 2163 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 152: // call: "builtin" "(" vargs ")"
#line 582 "src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 2169 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 153: // call: "stack_mode" "(" ")"
#line 583 "src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 2175 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 154: // call: "stack_mode" "(" vargs ")"
#line 584 "src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 2181 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 155: // map: "map"
#line 588 "src/parser.yy"
                                  { yylhs.value.as < ast::Map * > () = new ast::Map(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 2187 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 156: // map: "map" "[" vargs "]"
#line 589 "src/parser.yy"
                                  { yylhs.value.as < ast::Map * > () = new ast::Map(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 2193 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 157: // var: "variable"
#line 593 "src/parser.yy"
                    { yylhs.value.as < ast::Variable * > () = new ast::Variable(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 2199 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 158: // map_or_var: var
#line 597 "src/parser.yy"
                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Variable * > (); }
#line 2205 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 159: // map_or_var: map
#line 598 "src/parser.yy"
                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Map * > (); }
#line 2211 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 160: // vargs: vargs "," expr
#line 602 "src/parser.yy"
                               { yylhs.value.as < ast::ExpressionList * > () = yystack_[2].value.as < ast::ExpressionList * > (); yystack_[2].value.as < ast::ExpressionList * > ()->push_back(yystack_[0].value.as < ast::Expression * > ()); }
#line 2217 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 161: // vargs: expr
#line 603 "src/parser.yy"
                               { yylhs.value.as < ast::ExpressionList * > () = new ast::ExpressionList; yylhs.value.as < ast::ExpressionList * > ()->push_back(yystack_[0].value.as < ast::Expression * > ()); }
#line 2223 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 162: // compound_op: "<<="
#line 607 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::LEFT; }
#line 2229 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 163: // compound_op: "&="
#line 608 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::BAND; }
#line 2235 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 164: // compound_op: "|="
#line 609 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::BOR; }
#line 2241 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 165: // compound_op: "^="
#line 610 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::BXOR; }
#line 2247 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 166: // compound_op: "/="
#line 611 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::DIV; }
#line 2253 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 167: // compound_op: "-="
#line 612 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::MINUS; }
#line 2259 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 168: // compound_op: "%="
#line 613 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::MOD; }
#line 2265 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 169: // compound_op: "*="
#line 614 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::MUL; }
#line 2271 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 170: // compound_op: "+="
#line 615 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::PLUS; }
#line 2277 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 171: // compound_op: ">>="
#line 616 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::RIGHT; }
#line 2283 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;


#line 2287 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  Parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  Parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // Parser::context.
  Parser::context::context (const Parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  Parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    const int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        const int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        const int yychecklim = yylast_ - yyn + 1;
        const int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }






  int
  Parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  Parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short Parser::yypact_ninf_ = -156;

  const short Parser::yytable_ninf_ = -145;

  const short
  Parser::yypact_[] =
  {
     -28,   -51,   -28,    61,  -156,   -28,   -28,  -156,  -156,    90,
    -156,    14,  -156,    10,  -156,  -156,  -156,  -156,  -156,  -156,
     510,    98,  -156,  -156,  -156,  -156,  -156,  -156,  -156,  -156,
    -156,  -156,  -156,  -156,  -156,  -156,  -156,  -156,  -156,  -156,
    -156,   174,   196,    31,   196,  -156,  -156,  -156,   110,   121,
      17,   149,    21,    50,  -156,   175,  -156,  -156,    82,  -156,
    -156,    -3,  -156,  -156,   510,   172,  -156,    -2,   170,   156,
     157,   163,   182,   119,   115,    84,     9,  -156,  -156,  -156,
    -156,   -11,  -156,  -156,  -156,    67,    93,  -156,   143,  -156,
    -156,   210,    24,    22,   211,  -156,  -156,    39,  -156,  -156,
    -156,  -156,  -156,   216,   258,   300,   342,   384,   426,   510,
     468,   510,   238,   280,  -156,  -156,   510,   510,   510,   510,
     510,   510,   510,   510,   510,   510,   510,   510,   510,   510,
     510,   510,   510,   510,   510,  -156,  -156,  -156,  -156,   215,
     217,   219,  -156,  -156,  -156,   223,    93,   227,  -156,  -156,
    -156,  -156,   218,  -156,   144,   532,  -156,   155,   510,    70,
     510,  -156,    -1,  -156,   510,    83,   234,   232,   233,  -156,
    -156,    44,  -156,   134,  -156,   136,  -156,   150,     2,  -156,
     176,   245,  -156,  -156,  -156,   254,   170,   156,   157,   163,
     182,   119,   119,   115,   115,   115,   115,     9,     9,  -156,
    -156,  -156,    84,    84,   510,     5,   510,  -156,  -156,    93,
     510,   510,  -156,  -156,  -156,  -156,  -156,  -156,  -156,  -156,
    -156,  -156,   510,   510,   510,   253,  -156,   510,   255,  -156,
    -156,   260,   183,  -156,  -156,   280,   280,  -156,   510,  -156,
    -156,  -156,  -156,  -156,  -156,   510,   256,    31,   263,   265,
     276,  -156,  -156,  -156,  -156,  -156,  -156,  -156,  -156,   510,
    -156,  -156,   277,   278,  -156,  -156,    98,    98,    98,    98,
    -156,  -156,  -156,   244,  -156,  -156,  -156,     3,  -156,  -156,
    -156
  };

  const unsigned char
  Parser::yydefact_[] =
  {
       6,     0,     6,     0,    35,     6,     6,     3,     1,    35,
      18,    37,    22,    23,     4,     5,     2,    17,    20,    35,
       0,     0,    28,    32,    33,    39,    30,    31,    29,   141,
     142,   143,   140,    26,    25,    38,    27,   144,    34,    24,
      21,     0,     0,    97,     0,    94,    96,    95,     0,     0,
      69,   142,    70,    65,    67,   155,   157,   139,    68,    72,
      75,    89,    78,   129,     0,     0,    98,    99,   101,   103,
     105,   107,   109,   111,   114,   126,   119,   122,    81,    82,
      66,     0,    80,   159,   158,    73,    44,    19,     0,    14,
       8,     0,    65,     0,     7,    12,    13,     0,    85,    90,
     138,    86,    91,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    88,    36,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    93,    92,    83,    84,     0,
       0,     0,    52,    51,    50,     0,    44,    42,    48,    45,
      46,    49,    78,    47,   159,   158,    16,     0,     0,     0,
       0,    15,     0,    71,     0,     0,     0,     0,     0,   151,
     161,     0,   145,     0,   147,     0,   149,     0,     0,   153,
       0,     0,    87,    76,    77,     0,   102,   104,   106,   108,
     110,   112,   113,   115,   116,   117,   118,   120,   121,   123,
     124,   125,   127,   128,     0,     0,     0,    40,    43,    44,
       0,     0,   162,   171,   170,   167,   169,   166,   168,   163,
     164,   165,     0,     0,     0,     0,   131,     0,     0,   130,
      11,     0,     0,   134,   135,     0,     0,   152,     0,   146,
     148,   150,   156,   154,    79,     0,     0,     0,     0,     0,
       0,    41,    60,    61,    63,    62,    64,     9,   132,     0,
      10,    74,     0,     0,   160,   100,     0,     0,     0,     0,
     133,   136,   137,    56,    54,    53,    55,     0,    58,    59,
      57
  };

  const short
  Parser::yypgoto_[] =
  {
    -156,  -156,    99,   200,  -156,  -156,   195,  -156,   298,  -156,
     289,  -156,  -156,   -10,  -155,  -134,  -156,  -156,  -156,  -156,
      35,  -156,  -156,  -156,  -156,   -81,  -156,  -156,   -19,    68,
    -156,   206,   199,   205,   208,   204,    85,    -9,    76,    87,
     -62,  -156,  -156,   124,   -13,  -156,   -80,   -75,   120,   -69,
     186
  };

  const short
  Parser::yydefgoto_[] =
  {
       0,     3,     4,    93,    94,    95,    96,     9,    10,    11,
      12,    13,    21,    59,    87,   145,   146,   147,   148,   149,
     150,   280,   151,    60,    61,    62,    63,    64,   170,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,   171,
     222
  };

  const short
  Parser::yytable_[] =
  {
      39,    65,   114,    38,   111,   152,   154,   230,    86,   116,
     242,   155,   208,    22,    18,   238,   135,    23,    24,    25,
       5,     6,    97,   117,    25,     1,   105,    19,   136,    98,
     107,   101,   160,   108,   158,   133,    26,   173,   175,   177,
     178,   180,     2,   247,  -141,   112,   113,   134,  -143,   163,
      27,  -140,   164,   139,   237,    20,  -141,   238,    28,   108,
    -143,     8,   161,  -140,   159,   152,   154,   153,   199,   200,
     201,   155,    29,    30,    31,   251,   231,  -140,    32,    33,
     227,    35,    57,    34,   166,   168,    35,    36,    37,  -140,
      16,   110,   181,   233,   137,   232,   226,   185,   229,   183,
     184,     7,    41,    86,    14,    15,   138,    25,   100,  -144,
     228,   273,   274,   275,   276,   193,   194,   195,   196,   103,
      42,  -144,   278,   161,   130,   131,   132,   153,   152,   154,
     104,    43,    44,    45,   155,   128,   129,   124,   125,    46,
      47,   126,   127,   139,   239,   140,   240,   238,   141,   238,
     142,   143,   144,    48,    49,    50,    51,    52,   106,   211,
     241,    53,    99,   238,   102,   258,    54,    55,    56,    35,
      57,    58,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   109,    41,   115,   246,   243,   250,    25,   238,
     153,   252,   253,   261,   118,   248,   238,   270,   122,   123,
     119,    42,   120,   254,   255,   256,   121,   191,   192,   202,
     203,   156,    43,    44,    45,   197,   198,   157,   162,   264,
      46,    47,   262,   263,   204,    41,   205,    88,   206,   207,
      25,   209,   225,   210,    48,    49,    50,    51,    52,    89,
      90,    91,    92,    42,   234,   235,   236,    54,    55,    56,
      35,    57,    58,   244,    43,    44,    45,   245,    29,    30,
      31,   257,    46,    47,    32,   259,   266,    41,   260,    88,
      55,    56,    25,   267,    37,   268,    48,    49,    50,    51,
      52,    89,    90,    91,    53,    42,   269,   271,   272,    54,
      55,    56,    35,    57,    58,   277,    43,    44,    45,   167,
      29,    30,    31,   165,    46,    47,    32,    17,    40,    41,
     169,    88,   279,   265,    25,   182,    37,   187,    48,    49,
      50,    51,    52,   186,   188,   190,    53,    42,   189,   249,
       0,    54,    55,    56,    35,    57,    58,     0,    43,    44,
      45,   224,    29,    30,    31,     0,    46,    47,    32,     0,
       0,    41,   172,     0,     0,     0,    25,     0,    37,     0,
      48,    49,    50,    51,    52,     0,     0,     0,    53,    42,
       0,     0,     0,    54,    55,    56,    35,    57,    58,     0,
      43,    44,    45,     0,     0,     0,     0,     0,    46,    47,
       0,     0,     0,    41,   174,     0,     0,     0,    25,     0,
       0,     0,    48,    49,    50,    51,    52,     0,     0,     0,
      53,    42,     0,     0,     0,    54,    55,    56,    35,    57,
      58,     0,    43,    44,    45,     0,     0,     0,     0,     0,
      46,    47,     0,     0,     0,    41,   176,     0,     0,     0,
      25,     0,     0,     0,    48,    49,    50,    51,    52,     0,
       0,     0,    53,    42,     0,     0,     0,    54,    55,    56,
      35,    57,    58,     0,    43,    44,    45,     0,     0,     0,
       0,     0,    46,    47,     0,     0,     0,    41,   179,     0,
       0,     0,    25,     0,     0,     0,    48,    49,    50,    51,
      52,     0,     0,     0,    53,    42,     0,     0,     0,    54,
      55,    56,    35,    57,    58,     0,    43,    44,    45,     0,
       0,     0,     0,     0,    46,    47,     0,     0,     0,    41,
       0,     0,     0,     0,    25,     0,     0,     0,    48,    49,
      50,    51,    52,     0,     0,     0,    53,    42,     0,     0,
       0,    54,    55,    56,    35,    57,    58,   223,    43,    44,
      45,     0,     0,     0,     0,     0,    46,    47,     0,     0,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
      48,    49,    50,    51,    52,     0,     0,     0,    53,     0,
       0,     0,     0,    54,    55,    56,    35,    57,    58
  };

  const short
  Parser::yycheck_[] =
  {
      13,    20,    64,    13,     7,    86,    86,     8,     5,    11,
       8,    86,   146,     3,     0,    13,    27,     7,     8,    14,
      71,    72,    41,    25,    14,    53,     9,    13,    39,    42,
       9,    44,    10,     9,    10,    26,    26,   106,   107,   108,
     109,   110,    70,    38,    27,    48,    49,    38,    27,    10,
      40,    27,    13,    50,    10,    41,    39,    13,    48,     9,
      39,     0,    40,    39,    40,   146,   146,    86,   130,   131,
     132,   146,    62,    63,    64,   209,    77,    27,    68,    69,
      10,    76,    77,    73,   103,   104,    76,    77,    78,    39,
       0,     9,   111,    10,    27,   164,   158,   116,   160,   112,
     113,     2,     9,     5,     5,     6,    39,    14,    77,    27,
      40,   266,   267,   268,   269,   124,   125,   126,   127,     9,
      27,    39,   277,    40,    40,    41,    42,   146,   209,   209,
       9,    38,    39,    40,   209,    20,    21,    18,    19,    46,
      47,    22,    23,    50,    10,    52,    10,    13,    55,    13,
      57,    58,    59,    60,    61,    62,    63,    64,     9,    15,
      10,    68,    42,    13,    44,   227,    73,    74,    75,    76,
      77,    78,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,     7,     9,    12,   204,    10,   206,    14,    13,
     209,   210,   211,    10,    24,   205,    13,   259,    16,    17,
      44,    27,    45,   222,   223,   224,    43,   122,   123,   133,
     134,    68,    38,    39,    40,   128,   129,     7,     7,   238,
      46,    47,   235,   236,     9,     9,     9,    53,     9,     6,
      14,     4,    77,    15,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    27,    10,    13,    13,    73,    74,    75,
      76,    77,    78,     8,    38,    39,    40,     3,    62,    63,
      64,     8,    46,    47,    68,    10,    10,     9,     8,    53,
      74,    75,    14,    10,    78,    10,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    27,    10,    10,    10,    73,
      74,    75,    76,    77,    78,    51,    38,    39,    40,   104,
      62,    63,    64,   103,    46,    47,    68,     9,    19,     9,
      10,    53,   277,   245,    14,    77,    78,   118,    60,    61,
      62,    63,    64,   117,   119,   121,    68,    27,   120,   205,
      -1,    73,    74,    75,    76,    77,    78,    -1,    38,    39,
      40,   155,    62,    63,    64,    -1,    46,    47,    68,    -1,
      -1,     9,    10,    -1,    -1,    -1,    14,    -1,    78,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    -1,    68,    27,
      -1,    -1,    -1,    73,    74,    75,    76,    77,    78,    -1,
      38,    39,    40,    -1,    -1,    -1,    -1,    -1,    46,    47,
      -1,    -1,    -1,     9,    10,    -1,    -1,    -1,    14,    -1,
      -1,    -1,    60,    61,    62,    63,    64,    -1,    -1,    -1,
      68,    27,    -1,    -1,    -1,    73,    74,    75,    76,    77,
      78,    -1,    38,    39,    40,    -1,    -1,    -1,    -1,    -1,
      46,    47,    -1,    -1,    -1,     9,    10,    -1,    -1,    -1,
      14,    -1,    -1,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    -1,    68,    27,    -1,    -1,    -1,    73,    74,    75,
      76,    77,    78,    -1,    38,    39,    40,    -1,    -1,    -1,
      -1,    -1,    46,    47,    -1,    -1,    -1,     9,    10,    -1,
      -1,    -1,    14,    -1,    -1,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    -1,    68,    27,    -1,    -1,    -1,    73,
      74,    75,    76,    77,    78,    -1,    38,    39,    40,    -1,
      -1,    -1,    -1,    -1,    46,    47,    -1,    -1,    -1,     9,
      -1,    -1,    -1,    -1,    14,    -1,    -1,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    -1,    68,    27,    -1,    -1,
      -1,    73,    74,    75,    76,    77,    78,    15,    38,    39,
      40,    -1,    -1,    -1,    -1,    -1,    46,    47,    -1,    -1,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      60,    61,    62,    63,    64,    -1,    -1,    -1,    68,    -1,
      -1,    -1,    -1,    73,    74,    75,    76,    77,    78
  };

  const unsigned char
  Parser::yystos_[] =
  {
       0,    53,    70,    80,    81,    71,    72,    81,     0,    86,
      87,    88,    89,    90,    81,    81,     0,    87,     0,    13,
      41,    91,     3,     7,     8,    14,    26,    40,    48,    62,
      63,    64,    68,    69,    73,    76,    77,    78,    92,   123,
      89,     9,    27,    38,    39,    40,    46,    47,    60,    61,
      62,    63,    64,    68,    73,    74,    75,    77,    78,    92,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,     5,    93,    53,    65,
      66,    67,    68,    82,    83,    84,    85,   107,   123,   127,
      77,   123,   127,     9,     9,     9,     9,     9,     9,     7,
       9,     7,    48,    49,   119,    12,    11,    25,    24,    44,
      45,    43,    16,    17,    18,    19,    22,    23,    20,    21,
      40,    41,    42,    26,    38,    27,    39,    27,    39,    50,
      52,    55,    57,    58,    59,    94,    95,    96,    97,    98,
      99,   101,   104,   107,   125,   126,    68,     7,    10,    40,
      10,    40,     7,    10,    13,    82,   107,    85,   107,    10,
     107,   128,    10,   128,    10,   128,    10,   128,   128,    10,
     128,   107,    77,   123,   123,   107,   110,   111,   112,   113,
     114,   115,   115,   116,   116,   116,   116,   118,   118,   119,
     119,   119,   117,   117,     9,     9,     9,     6,    94,     4,
      15,    15,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,   129,    15,   129,    77,   119,    10,    40,   119,
       8,    77,   128,    10,    10,    13,    13,    10,    13,    10,
      10,    10,     8,    10,     8,     3,   107,    38,    92,   122,
     107,    94,   107,   107,   107,   107,   107,     8,   119,    10,
       8,    10,   123,   123,   107,   108,    10,    10,    10,    10,
     119,    10,    10,    93,    93,    93,    93,    51,    93,    99,
     100
  };

  const unsigned char
  Parser::yyr1_[] =
  {
       0,    79,    80,    81,    81,    81,    81,    82,    82,    82,
      82,    82,    82,    82,    83,    84,    85,    86,    86,    87,
      87,    88,    88,    89,    90,    90,    90,    90,    90,    90,
      90,    90,    90,    90,    90,    90,    91,    91,    92,    92,
      93,    94,    94,    94,    94,    95,    95,    96,    96,    96,
      97,    97,    97,    98,    98,    98,    99,    99,   100,   100,
     101,   101,   101,   101,   101,   102,   102,   102,   102,   102,
     102,   102,   102,   102,   102,   103,   103,   103,   103,   103,
     103,   103,   103,   103,   103,   103,   103,   104,   105,   105,
     105,   105,   105,   105,   106,   106,   106,   106,   107,   108,
     108,   109,   109,   110,   110,   111,   111,   112,   112,   113,
     113,   114,   114,   114,   115,   115,   115,   115,   115,   116,
     116,   116,   117,   117,   117,   117,   118,   118,   118,   119,
     119,   119,   119,   119,   120,   120,   121,   121,   122,   122,
     123,   123,   123,   123,   123,   124,   124,   124,   124,   124,
     124,   124,   124,   124,   124,   125,   125,   126,   127,   127,
     128,   128,   129,   129,   129,   129,   129,   129,   129,   129,
     129,   129
  };

  const signed char
  Parser::yyr2_[] =
  {
       0,     2,     3,     2,     3,     3,     0,     1,     1,     4,
       4,     3,     1,     1,     1,     2,     2,     2,     1,     3,
       2,     3,     1,     1,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     0,     3,     0,     1,     1,
       3,     3,     1,     2,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     5,     5,     5,     5,     7,     1,     1,
       3,     3,     3,     3,     3,     1,     1,     1,     1,     1,
       1,     3,     1,     1,     5,     1,     3,     3,     1,     4,
       1,     1,     1,     2,     2,     2,     2,     3,     2,     1,
       2,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       5,     1,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     1,     3,     3,     1,     3,     3,     3,     3,     1,
       3,     3,     1,     3,     3,     3,     1,     3,     3,     1,
       4,     4,     5,     6,     4,     4,     6,     6,     2,     1,
       1,     1,     1,     1,     1,     3,     4,     3,     4,     3,
       4,     3,     4,     3,     4,     1,     4,     1,     1,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const Parser::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "\":\"", "\";\"",
  "\"{\"", "\"}\"", "\"[\"", "\"]\"", "\"(\"", "\")\"", "\"?\"",
  "\"end predicate\"", "\",\"", "\"$#\"", "\"=\"", "\"==\"", "\"!=\"",
  "\"<=\"", "\">=\"", "\"<<\"", "\">>\"", "\"<\"", "\">\"", "\"&&\"",
  "\"||\"", "\"+\"", "\"++\"", "\"<<=\"", "\">>=\"", "\"+=\"", "\"-=\"",
  "\"*=\"", "\"/=\"", "\"%=\"", "\"&=\"", "\"|=\"", "\"^=\"", "\"-\"",
  "\"--\"", "\"*\"", "\"/\"", "\"%\"", "\"&\"", "\"|\"", "\"^\"", "\"!\"",
  "\"~\"", "\".\"", "\"->\"", "\"if\"", "\"else\"", "\"unroll\"",
  "\"struct\"", "\"union\"", "\"while\"", "\"for\"", "\"return\"",
  "\"continue\"", "\"break\"", "\"sizeof\"", "\"offsetof\"", "\"builtin\"",
  "\"call\"", "\"call_builtin\"", "\"integer type\"", "\"builtin type\"",
  "\"sized type\"", "\"identifier\"", "\"path\"",
  "\"preprocessor directive\"", "\"struct definition\"", "\"enum\"",
  "\"string\"", "\"map\"", "\"variable\"", "\"positional parameter\"",
  "\"integer\"", "\"stack_mode\"", "$accept", "program", "c_definitions",
  "type", "int_type", "pointer_type", "struct_type", "probes", "probe",
  "attach_points", "attach_point", "attach_point_def", "pred", "param",
  "block", "stmt_list", "block_stmt", "expr_stmt", "jump_stmt",
  "loop_stmt", "if_stmt", "block_or_if", "assign_stmt", "primary_expr",
  "postfix_expr", "tuple_access_expr", "unary_expr", "unary_op", "expr",
  "conditional_expr", "logical_or_expr", "logical_and_expr", "or_expr",
  "xor_expr", "and_expr", "equality_expr", "relational_expr", "shift_expr",
  "muli_expr", "addi_expr", "cast_expr", "sizeof_expr", "offsetof_expr",
  "int", "ident", "call", "map", "var", "map_or_var", "vargs",
  "compound_op", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  Parser::yyrline_[] =
  {
       0,   172,   172,   176,   177,   178,   179,   183,   184,   205,
     214,   217,   220,   221,   225,   242,   245,   249,   250,   254,
     264,   277,   278,   282,   286,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   312,   316,   317,   322,   333,
     337,   344,   345,   349,   350,   354,   355,   359,   360,   365,
     369,   370,   371,   375,   376,   377,   381,   382,   386,   387,
     391,   396,   397,   398,   403,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   430,   432,   433,   435,   437,
     438,   439,   440,   441,   442,   444,   445,   450,   456,   457,
     458,   459,   461,   462,   466,   467,   468,   469,   473,   477,
     478,   483,   484,   488,   489,   493,   494,   498,   499,   504,
     505,   509,   510,   511,   515,   516,   517,   518,   519,   523,
     524,   525,   529,   530,   531,   532,   536,   537,   538,   542,
     543,   545,   546,   547,   551,   552,   556,   558,   562,   563,
     567,   568,   569,   570,   571,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   588,   589,   593,   597,   598,
     602,   603,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616
  };

  void
  Parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  Parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


#line 4 "src/parser.yy"
} //  bpftrace 
#line 3031 "/builddir/build/BUILD/bpftrace-0.19.1/aarch64-OpenCloudOS-linux-gnu/parser.tab.cc"

#line 619 "src/parser.yy"


void bpftrace::Parser::error(const location &l, const std::string &m)
{
  driver.error(l, m);
}
